import random
import kitems
import curses
import string
class kactor(object):
  def __init__(self, char, do_turn, name):
    self.char = char
    self.colour = curses.COLOR_RED
    self.name = name
    self.location = None
    self.do_turn = do_turn
    self.base_stats = {'spd':10, 'hp':100, 'atk':10,'def':10,
                       'dam':1,'arm':0, 'cat':1,'cdf':0}
    if char in string.uppercase+'p':
      for k in self.base_stats.keys():
        self.base_stats[k] += random.randint(1,3)
      self.base_stats['hp'] *= 10
    if char == 'h':
      self.base_stats['spd'] += 2
    self.hp = self.base_stats['hp']
    self.is_daemon = False
    self.equip = kitems.kequipment()
    #todo make another ring slot, maybe a 10th too (bow?)
    self.status = {}
    self.base_inv_size = 10
    self.kill_count = 0
    self.pray_count = 0
    self.inventory = kitems.kinventory(10)
##    if char != '@':
##      self.inventory.inv = [-3]*10
    self.random_walk_memory = [None]*5

  def loaded(self):
    if -1 in self.inventory:
      return True
    if -2 in self.inventory:
      return True
    return self.inventory.full()

  def load(self):
    if -1 in self.inventory:
      return '#'
    if -2 in self.inventory:
      return '&'

  def attack(self):
    return self.base_stats['atk']
  def defence(self):
    return self.base_stats['def']
  def damage(self):
    return self.base_stats['dam']
  def armour(self):
    return self.base_stats['arm']
  def crit_attack(self):
    return self.base_stats['cat']
  def crit_defence(self):
    return self.base_stats['cdf']
  def dam_types(self):
    return set(['phys'])
  def speed(self):
    return self.base_stats['spd']
  
    
class kdigger(kactor):
  def __init__(self, do_turn):
    super(kdigger, self).__init__('d', do_turn, 'a digger')
    self.last_pickup = 1
    self.base_stats['spd'] += random.randint(-3,3)
    self.base_stats['hp'] = 60
    self.hp = 60

  def pickup_prob(self):
    return 0.8/max(1,8-self.last_pickup)

class kzombie(kactor):
  def __init__(self, do_turn):
    super(kzombie, self).__init__('z', do_turn, 'a zombie')
    self.base_stats['spd'] += random.randint(-3,3)
    self.base_stats['hp'] = 30
    self.hp = 30
  
class kplayer(kactor):
  def __init__(self, do_turn):
    super(kplayer, self).__init__('@', do_turn,'you')# 'the Big Damn Hero')
    self.base_stats['hp'] *= 2
    self.hp = self.base_stats['hp']
    

class kdaemon:
  def __init__(self, process, name):
    self.process = process
    self.is_daemon = True
    self.register = {}
    self.causes = {}
    self.name = name
  
  def do_turn(self, ownID):
    removal = []
    for actorID, magic in self.register.iteritems():
      self.register[actorID] = self.process(actorID, magic, self.causes[actorID])
      if self.register[actorID] < 1:
        removal.append(actorID)
    for actorID in removal:
      del self.register[actorID]
      del self.causes[actorID]
    return self.speed()
        
  def speed(self):
    return 100
