import random
import krltools as k
import kitems

#these two should not be in this file!
k.setsize(15,15) #width, height
k.setorientation(random.choice([True,False]))

class ktile(object):
  def __init__(self, location, terrain):
    self.location = location
    self.terrain = terrain
    self.occupant = 0
    self.items = kitems.kinventory(10)
    self.last_seen = -20
    self.player_memory = ' '

  def blocked(self):
    if self.occupant != 0:
      return True
    if self.terrain != '.':
      return True
    return False

  def walkable(self):
    return self.terrain == '.'

  def blocks_los(self):
    return self.terrain == '#'

  def char(self):
    return self.terrain

  def empty(self):
    if self.terrain != '.':
      return False
    if not self.items.empty():
      return False
    if self.occupant != 0:
      return False
    return True

  def can_contain(self):
    if self.terrain != '.':
      return False
    if self.items.full():
      return False
    return True
  
def random_map(width, height):
      return[[ktile((i,j),random.choice(
        ['.','#','.','#','&','.','#','.','.','.']))
              for i in range(width)] for j in range(height)]

#maze_repr = {0:'.',1:'#',3:'x',2:'v',4:'<',6:'>',8:'^'}
#def pr(maze):
#  for row in maze:
#    print ''.join(map(lambda x: maze_repr[x],row))

#def pri(maze):
#  for row in maze:
#    print ''.join(map(ktile.char,row))

def random_maze(width, height):
  orth = {2:k.down, 4:k.left, 6:k.right, 8:k.up}
  maze = [[0]*width for x in range(height)]
  possible = set()
  def nd(d,loc):
    return k.normalise(orth[d](k.normalise(loc)))
  def update(loc):
    for idx,d in orth.iteritems():
      v = k.mget(maze, d(loc))
      if v in [1,3]:
        pass
      elif v in [2,4,6,8]:
        if v != idx:
          k.mset(maze, d(loc), 3)
          try:
            possible.remove(k.normalise(d(loc)))
          except KeyError:
            pass
      else:
        if v == 0:
          k.mset(maze, d(loc),idx)
          possible.add(k.normalise(d(loc)))
  #0 unoccupied, 1 occupied, 3 forbidden, 2,4,6,8 dirs
  x,y = random.randint(0,width-1),random.randint(0,height-1)
  loc = (x,y,False)
  k.mset(maze, loc, 1)
  update(loc)
  while possible:
    length = random.randint(0,(width+height)/2)
    loc = random.choice(list(possible))
    possible.remove(k.normalise(loc))
    d = k.mget(maze, loc)
    for i in range(length):
      k.mset(maze, loc,1)
      update(loc)
      try:
        possible.remove(k.normalise(loc))
      except KeyError:
        pass
      loc = nd(d,loc)
      if i == length-1:
        if k.mget(maze, loc) == 1:
          print("\nDEATH'n")
        k.mset(maze, loc, 3)
        try:
          possible.remove(k.normalise(loc))
        except KeyError:
          pass
        break
      if k.mget(maze, loc) in [1,3]:
        break
  return process_maze(maze)

def process(tile):
  if tile == 1:
    return random.choice(['#','#','&','#','#','#','&','#','#','#','#','.'])
  else:
    return '.'
def process_maze(maze):
  height = len(maze)
  width = len(maze[0])
  return [[ktile((i,j,False),process(maze[j][i]))
           for i in range(width)] for j in range(height)]

  
