import string
#call this before using anything else
def setsize(width, height):
  global xsize, ysize
  xsize = width
  ysize = height

#call this at least once before using anything else
def setorientation(horiz):
  global flip, lateral_flip, up, down, left, right, dirs
  lateral_flip = horiz
  if horiz:
    flip, up, down, left, right = (fliplat, uplat, downlat,
                                   leftlat, rightlat)
  else:
    flip, up, down, left, right = (fliplong, uplong, downlong,
                                   leftlong, rightlong)
  dirs = {8:up, 2:down, 4:left,6:right,1:sw,3:se,7:nw,9:ne, 5:rest}
vi_keys = {ord('h'):4,ord('l'):6,ord('y'):7,ord('u'):9,
           ord('b'):1,ord('n'):3,ord('j'):2,ord('k'):8}
displacements = {8:(0,-1),2:(0,1),4:(-1,0),6:(1,0)}

def rearr_step((c1,c2),radius):
  choices = [(di,(c1+d1,c2+d2)) for di, (d1,d2) in displacements.iteritems()
             if c1+d1 <=radius and c2+d2 <=radius]
  return choices

def fliplat((x,y,u)):
  return (x,-y-1,not u)

def fliplong((x,y,u)):
  return (-x-1,y,not u)

def bound((x,y,u)):
  return (x % xsize, y % ysize, u)

def normalise((x,y,u)):
  if u:
    return bound(flip((x,y,u)))
  return bound((x,y,u))

def mget(m,loc):
  return _get(m,normalise(loc))

#don't call this
def _get(m,(x,y,u)):
  return m[y][x]

def mset(m,loc,v):
  _set(m,normalise(loc),v)

#don't call this
def _set(m,(x,y,u),v):
  m[y][x] = v

#### vvvv none of these are for external use

def uplat((x,y,u)):
  return (x,y-1,u)

def downlat((x,y,u)):
  return (x,y+1,u)

def leftlat((x,y,u)):
  if x % xsize == 0:
    return (x-1,y,not u)
  return (x-1,y,u)

def rightlat((x,y,u)):
  if x % xsize == xsize - 1:
    return (x+1,y,not u)
  return (x+1,y,u)

def uplong((x,y,u)):
  if y % ysize == 0:
    return (x,y-1,not u)
  return (x,y-1,u)

def downlong((x,y,u)):
  if y % ysize == ysize - 1:
    return (x,y+1,not u)
  return (x,y+1,u)

def leftlong((x,y,u)):
  return (x-1,y,u)

def rightlong((x,y,u)):
  return (x+1,y,u)

#### ^^^^ none of those are for external use

def rest(loc):
  return loc

naive_dirs = {8:uplat,2:downlat,4:leftlong,6:rightlong,
              1:lambda x:downlat(leftlong(x)),
              3:lambda x:downlat(rightlong(x)),
              7:lambda x:uplat(leftlong(x)),
              9:lambda x:uplat(rightlong(x)),
              5:rest}

def ne(loc):
  return up(right(loc))

def nw(loc):
  return up(left(loc))

def se(loc):
  return down(right(loc))

def sw(loc):
  return down(left(loc))

def go(start, direction, dist):
  return [reduce(lambda x,y: direction(x), range(i), start)
          for i in range(1,dist)]

def allgo(line, direction, dist):
  return [reduce(lambda x,y: map(direction,x), range(i), line)
          for i in range(1,dist)]

def sized_viewport(loc, w, h):
  l = list(reversed(go(loc,left,(w/2)+1)))
  r = go(loc,right,(w/2)+1)
  mid = l + [loc] + r
  top = list(reversed(allgo(mid,up,(h/2)+1)))
  bot = allgo(mid,down,(h/2)+1)
  return top + [mid] + bot

##def string(m,loc,player):
##  if normalise(loc) == normalise(player):
##    return '********'
##  return (str(int(mget(m,loc)*10000))+'        ')[:8]
##  #return (str(int(m[y][x]*10000))+'     ')[:6]

#pointers = {1:'/',9:'/',3:'\\',7:'\\',2:'v',8:'^',4:'<',6:'>',5:'*'}
#pointers = {1:'L',9:'J',3:'\\',7:'r',2:'v',8:'^',4:'<',6:'>',5:'*'}

##def point(m,sc,loc, player):
##  if not mget(m,loc).walkable():
##    return '#'
##  if normalise(loc) == normalise(player):
##    return '@'
##  return min([(mget(sc,d(loc)),pointers[idx]) for idx,d in dirs.iteritems()
##              if mget(m,d(loc)).walkable()])[1]
##  
##
##def pr(m,sc,player):
##  return [''.join([string(sc,(x,y,False),player) for x in range(xsize)])
##     for y in range(ysize)]
##  #for y in range(ysize):
##  #  print ''.join([point(m,sc,(x,y,False),player) for x in range(xsize)])
##

def irange(start, finish):
    """
    This is a naive inclusive range function.
 
    >>> irange(1, 1)
    [1]
    >>> irange(1, 4)
    [1, 2, 3, 4]
    >>> irange(4, 1)
    [4, 3, 2, 1]
    """
    if start == finish:
        return [start]
    if start < finish:
        return range(start, finish + 1)
    if start > finish:
        return range(start, finish - 1, -1)

step_code = {(-1,-1):7,(0,-1):8,(1,-1):9,(-1,0):4,(1,0):6,
             (-1,1):1,(0,1):2,(1,1):3,(0,0):5}
rev = {1:9,9:1,3:7,7:3,4:6,6:4,2:8,8:2}

#draw a line from (x0,y0) to origin,
#return steps from origin to (x0,y0)
def bresenham_steps((x0,y0)):#,to):
  #(x0,y0) = (fro)
  (x1,y1) = (0,0)#(x1,y1,u1) = normalise(to)
  steep = (abs(y1 - y0) > abs(x1 - x0))
  if steep:
    x0,y0 = y0,x0
    x1,y1 = y1,x1
  if x0 > x1:
         x0,x1 = x1,x0
         y0,y1 = y1,y0
  deltax = x1 - x0
  xstep = (x1-x0)/abs(x1-x0)
  deltay = abs(y1-y0)
  error = deltax/2
  #squares = []
  steps = []
  y = y0
  if y0 < y1:
    ystep = 1
  else:
    ystep = -1
  ycode = ystep
  if steep:
    invert = (y,x0) != (0,0)
  else:
    invert = (x0,y) != (0,0)
  for x in irange(x0,x1):
    if steep:
      #squares.append((y,x))
      #invert = (y,x) != (0,0)
      if x != x0:
        #if squares[0] != (0,0):
        if invert:
          steps.append(rev[step_code[(ycode,xstep)]])
        else:
          steps.append(step_code[(ycode,xstep)])
    else:
      #squares.append((x,y))
      #invert = (y,x) != (0,0)
      if x != x0:
        #if squares[0] != (0,0):
        if invert:
          steps.append(rev[step_code[(xstep,ycode)]])
        else:
          steps.append(step_code[(xstep,ycode)])
    error = error - deltay
    if error < 0:
      y += ystep
      ycode = ystep
      error += deltax
    else:
      ycode = 0
  #if squares[0] == (0,0):
  if invert:
    return list(reversed(steps))#steps#, squares, True
  else:
    return list(reversed(steps))#, list(reversed(squares)), False

def tree_add(tree, path):
  if path == []:
    tree[5] = {}
    return
  step = path.pop()
  if tree.has_key(step):
    tree_add(tree[step],path)
  else:
    tree[step] = {}
    tree_add(tree[step],path)

def all_bres(r,exclude_origin=False):
  t = {}
  for i in range(-r,r+1):
    for j in range(-r,r+1):
      if (i,j) != (0,0):
        tree_add(t,bresenham_steps((i,j)))
      elif not exclude_origin:
        t[5] = {}
  return t

def tree_iter(t,f,block,loc):
  #print loc,block(loc)
  if not block(loc):
    for tr in t:
      if tr == 5:
        f(loc)
      else:
        tree_iter(t[tr],f,block,dirs[tr](loc))
  elif 5 in t:
    f(loc)

def capitalise(string):
  return string[0].capitalize()+string[1:]

typable = map(ord,string.ascii_letters+string.digits+string.punctuation+' ')
